searchData={"items":[{"type":"module","title":"Pgmq","doc":"Thin wrapper over the pgmq extension\n\nProvides APIs for sending, reading, archiving and deleting messages.\n\n#","ref":"Pgmq.html"},{"type":"module","title":"Use-macros - Pgmq","doc":"You can `use Pgmq` for the convenience of having a standardized repo and less\nconvoluted function calls. By defining:\n```\n  # lib/my_app/pgmq.ex\n  defmodule MyApp.Pgmq do\n    use Pgmq, repo: MyApp.Repo\n  end\n```\n\nYou can then call `MyApp.Pgmq.send_message(\"myqueue\", \"hello\")`, without passing\nin the `MyApp.Repo`","ref":"Pgmq.html#module-use-macros"},{"type":"function","title":"Pgmq.archive_messages/3","doc":"Archives list of messages, removing them from the queue and putting\nthem into the archive\n\nThis function can receive a list of either `Message.t()` or message ids. Mixed\nlists aren't allowed.","ref":"Pgmq.html#archive_messages/3"},{"type":"function","title":"Pgmq.create_queue/3","doc":"Creates a queue in the database\n\nNotice that the queue name must:\n- have less than 48 characters\n- start with a letter\n- have only letters, numbers, and `_`\n\nAccepts the following options:\n- `:unlogged`: Boolean indicating if the queue should be unlogged. Unlogged\nqueues are faster to write to, but data may be lost in database crashes or\nunclean exits. Can't be used together with `:partitioned`.\n- `:partitioned`: indicates if the queue is partitioned. Defaults to `false`. Requires\n`pg_partman` extension.\n- `:partition_interval:` interval to partition the queue, required if `:partitioned`\nis true.\n- `:retention_interval:` interval for partition retention, required if `:partitioned`\nis true.","ref":"Pgmq.html#create_queue/3"},{"type":"function","title":"Pgmq.delete_messages/3","doc":"Deletes a batch of messages, removing them from the queue\n\nThis function can receive a list of either `Message.t()` or message ids. Mixed\nlists aren't allowed.","ref":"Pgmq.html#delete_messages/3"},{"type":"function","title":"Pgmq.drop_queue/2","doc":"Deletes a queue from the database","ref":"Pgmq.html#drop_queue/2"},{"type":"function","title":"Pgmq.get_metrics/2","doc":"Returns metrics for a single queue","ref":"Pgmq.html#get_metrics/2"},{"type":"function","title":"Pgmq.get_metrics_all/1","doc":"Returns a list of queues with stats","ref":"Pgmq.html#get_metrics_all/1"},{"type":"function","title":"Pgmq.list_queues/1","doc":"Returns a list of queues","ref":"Pgmq.html#list_queues/1"},{"type":"function","title":"Pgmq.pop_message/2","doc":"Reads a message and instantly deletes it from the queue\n\nIf there are no messages in the queue, returns `nil`.","ref":"Pgmq.html#pop_message/2"},{"type":"function","title":"Pgmq.read_message/3","doc":"Reads one message from a queue\n\nReturns immediately. If there are no messages in the queue, returns `nil`.\n\nMessages read through this function are guaranteed not to be read by\nother calls for `visibility_timeout_seconds`.","ref":"Pgmq.html#read_message/3"},{"type":"function","title":"Pgmq.read_messages/4","doc":"Reads a batch of messages from a queue\n\nMessages read through this function are guaranteed not to be read by\nother calls for `visibility_timeout_seconds`.","ref":"Pgmq.html#read_messages/4"},{"type":"function","title":"Pgmq.read_messages_with_poll/5","doc":"Reads a batch of messages from a queue, but waits if no messages are available\n\nAccepts two options:\n- `:max_poll_seconds`: the maximum duration of the poll. Defaults to 5.\n- `:poll_interval_ms`: dictates how often the poll is made database\nside. Defaults to 250. Can be tuned for lower latency or less database load,\ndepending on your needs.\n\nWhen there are messages available in the queue, returns immediately.\nOtherwise, blocks until at least one message is available, or `max_poll_seconds`\nis reached.\n\nNotice that this function may put significant burden on the connection pool,\nas it may hold the connection for several seconds if there's no activity in\nthe queue.\n\nMessages read through this function are guaranteed not to be read by\nother calls for `visibility_timeout_seconds`.","ref":"Pgmq.html#read_messages_with_poll/5"},{"type":"function","title":"Pgmq.send_message/3","doc":"Sends one message to a queue","ref":"Pgmq.html#send_message/3"},{"type":"function","title":"Pgmq.send_messages/3","doc":"Sends a message batch to a queue","ref":"Pgmq.html#send_messages/3"},{"type":"function","title":"Pgmq.set_message_vt/4","doc":"Sets the visibility timeout of a message for X seconds from now","ref":"Pgmq.html#set_message_vt/4"},{"type":"type","title":"Pgmq.queue/0","doc":"Queue name","ref":"Pgmq.html#t:queue/0"},{"type":"type","title":"Pgmq.repo/0","doc":"An Ecto repository","ref":"Pgmq.html#t:repo/0"},{"type":"module","title":"Pgmq.Message","doc":"A message read from pgmq","ref":"Pgmq.Message.html"},{"type":"function","title":"Pgmq.Message.from_row/1","doc":"","ref":"Pgmq.Message.html#from_row/1"},{"type":"type","title":"Pgmq.Message.t/0","doc":"A message read from pgmq","ref":"Pgmq.Message.html#t:t/0"}],"content_type":"text/markdown"}